package  ORG.netlib.math.complex;



import  ORG.netlib.math.complex.Complex;




/**
* Tester for class <tt>Complex</tt>.
*
* <p>
* <pre>
* Last change:  ALM  30 Jun 97    1:44 am
* </pre>
**/

public class
TestComplex {

    public    static final String          MODULE              =  TestComplex.class.getName();
    public    static final String          VERSION             =  "1.0 alm";
    public    static final String          DATE                =  "Mon 30-Jun-97";
    public    static final String          AUTHOR              =  "sandy@almide.demon.co.uk";
    public    static final String          REMARK              =  "Tester for Complex class";



    /**
    * Used for testing class <tt>Complex</tt>.
    *
    * <p>
    *  <dl>
    *    <dt> <b>Usage:</b>
    *    <dd> <pre><b>java Complex</b> <i>method</i>  [<i>a</i>] [<i>bi</i>]  [<i>c</i>] [<i>di</i>]</pre>
    *  </dl>
    * <p>
    * <hr>
    * <dd><b>Help us <blink>BETA</blink> test class
    * <tt>Complex</tt>...</b></dd>
    * <p>
    * <dd>But first, <b><i>enable your browser's Java Console</i></b>.  On
    * Netscape, it's the <b>Options</b> menu, then the <b>Show Java Console</b>
    * item.
    *
    * <p>
    * <applet
    *     code="ComplexTestApplet.class"
    *     width=300
    *     height=24
    *     alt="ComplexTest Applet"
    *     align=texttop
    * >
    *     Make yours a Java enabled browser and OS!
    * </applet>
    * </p>
    *
    * <dd>Feel free to test out <i>any</i> method in the <tt>Complex</tt>
    * documentation.  For instance, to test out <i>sqrt(-1)</i> you'd type
    * <p>
    * <pre>
    *     sqrt -1 0
    * </pre>
    * <p>
    * and hit the <b>Test!</b> button.  You'll see the results appearing on the
    * Java Console.  Please mail us, <a
    * href="mailto:Jim Shapiro <jnshapi@argo.ecte.uswc.uswest.com>">Jim Shapiro</a>
    * in the USA, or <a
    * href="mailto:Alexander Anderson <sandy@almide.demon.co.uk>">Sandy Anderson</a>
    * in England, and give us your observations.
    * </dd>
    * <hr>
    * <p>
    **/

    /*
        System.out is static but NOT final, so it is OK to do

        PrintStream redirect = new PrintStream(someDataOutputStream);
        System.out = redirect;

        Instead, however, I  generally do something like

        PrintStream out;
        if (someCondition)
          out = new PrintStream(...);
        else
          out = System.out;

        Then I use out.println instead of System.out.println.
    */

    public static void
    main (String[] args) {
        // debug =  false; // !!!

        final String nanStr       =  "NaN";
        final String negInfStr    =  "-Infinity";
        final String posInfStr    =  "Infinity";
        final String traceFlagStr =  "-trace";

        boolean   setDebug   = false;
        int       maxArg     =  6;
        String    className;
        String    method     =  "unknown";
        double[]  doubleArgs =  {0.0, 0.0, 0.0, 0.0, 0.5, 999, 999}; //!!! epsilon woz ere
        boolean   noArgs     =  false;
        boolean   inputError =  false;
        double    scalar     =  100.0;
        double    tolerance;
        Complex   z1         =  null;
        Complex   z2;

        if (args.length == 0) {
            inputError =  true;
            noArgs     =  true;
        } else {
            method =  args[0];

            for (int i =  1; ((i < args.length)) ; i++) {                      // good enough...
                try {
                    if (args[i].equalsIgnoreCase(traceFlagStr)) {
                        setDebug =  true;
                    } else {
                        if (i >= maxArg) break;

                        String argsI = args[i];

                        if (argsI.equalsIgnoreCase(nanStr)) {
                            doubleArgs[i-1] =  Double.NaN;
                        } else if (argsI.equalsIgnoreCase(posInfStr)) {
                            doubleArgs[i-1] =  Double.POSITIVE_INFINITY;
                        } else if (argsI.equalsIgnoreCase(negInfStr)) {
                            doubleArgs[i-1] =  Double.NEGATIVE_INFINITY;
                        } else {
                            doubleArgs[i-1] =  Double.valueOf(args[i]).doubleValue();
                        };//endif
                    };//endif
                } catch (NumberFormatException e) {
                    inputError =  true;
                };//endtry
            };//endfor
        };//endif

        z1 =  Complex.cart(doubleArgs[0], doubleArgs[1]);
        z2 =  Complex.cart(doubleArgs[2], doubleArgs[3]);
        tolerance =  doubleArgs[4];
        className =  z1.getClass().getName();

        // Complex.objectCount =  0;                                              // !!!

        System.out.println();
        System.out.println("Tester...");
        System.out.println("Module : " + MODULE);
        System.out.println("Version: " + VERSION);
        System.out.println();
        System.out.println("Testing...");
        System.out.println("Module : " + className);
        System.out.println("Version: " + Complex.VERSION);
        System.out.println("Date   : " + Complex.DATE);
        System.out.println("Author : " + Complex.AUTHOR);
        System.out.println("Remark : " + Complex.REMARK);
        System.out.println();

        // if (setDebug) debug =  true; // !!!

        if (!noArgs) {
            System.out.println("z1         ==  " + z1);
            System.out.println("z2         ==  " + z2);
            System.out.println("tolerance  ==  " + tolerance);
            // System.out.println("trace      ==  " + debug); // !!!
            System.out.println();

//          if (method.equals("tolerance") || method.equals("setTolerance")) {
//              System.out.println(className + ".tolerance()  ==  " + tolerance());
//              System.out.println(className + ".setTolerance(" + z1.re + ");");
//              setTolerance(z1.re);
//              System.out.println(className + ".tolerance()  ==  " + tolerance());
//
            if (method.equals("real")) {
                System.out.println(className + "." + method + "(" + z1.re() + ")  ==  " + Complex.real(z1.re()));
            } else if (method.equals("cart")) {
                System.out.println(className + "." + method + z1 + "  ==  " + Complex.cart(z1.re(), z1.im()));
            } else if (method.equals("polar")) {
                System.out.println(className + "." + method + z1 + "  ==  " + Complex.polar(z1.re(), z1.im()));
            } else if (method.equals("pow")) {
                System.out.println(className + "." + method + "(" + z1.re() + ", " + z2 + ")  ==  " + Complex.pow(z1.re(), z2));
                System.out.println(className + "." + method + "(" + z1 + ", " + z2.re() + ")  ==  " + Complex.pow(z1, z2.re()));
                System.out.println(className + "." + method + "(" + z1 + ", " + z2 + ")  ==  " + Complex.pow(z1, z2));

            } else if (method.equals("isInfinite")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.isInfinite());
                System.out.println(z1 + ".isNaN()  ==  " + z1.isNaN());
            } else if (method.equals("isNaN")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.isNaN());
                System.out.println(z1 + ".isInfinite()  ==  " + z1.isInfinite());

            } else if (method.equals("equals")) {
                System.out.println(z1 + "." + method + "(" + z2 + ", " + tolerance +  ")  ==  " + z1.equals(z2, tolerance));
//              System.out.println(z1 + "." + method + z2 + "  ==  " + z1.equals(z2));

            } else if (method.equals("re")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.re());
            } else if (method.equals("im")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.im());

            } else if (method.equals("norm")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.norm());
            } else if (method.equals("abs")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.abs());

            } else if (method.equals("arg")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.arg());
            } else if (method.equals("neg")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.neg());
            } else if (method.equals("conj")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.conj());
//          } else if (method.equals("inv")) {
//              System.out.println(z1 + "." + method + "()  ==  " + z1.inv());
            } else if (method.equals("scale")) {
                System.out.println(z1 + "." + method + "(" + z2.re() + ")  ==  " + z1.scale(z2.re()));

            } else if (method.equals("add")) {
                System.out.println(z1 + "." + method + z2 + "  ==  " + z1.add(z2));
            } else if (method.equals("sub")) {
                System.out.println(z1 + "." + method + z2 + "  ==  " + z1.sub(z2));
            } else if (method.equals("mul")) {
                System.out.println(z1 + "." + method + z2 + "  ==  " + z1.mul(z2));
            } else if (method.equals("div")) {
                System.out.println(z1 + "." + method + z2 + "  ==  " + z1.div(z2));

            } else if (method.equals("sqrt")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.sqrt());

            } else if (method.equals("exp")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.exp());
            } else if (method.equals("log")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.log());

//          } else if (method.equals("log10")) {
//              System.out.println(z1 + "." + method + "()  ==  " + z1.log10());

            } else if (method.equals("sin")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.sin());
            } else if (method.equals("cos")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.cos());
            } else if (method.equals("tan")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.tan());

            } else if (method.equals("cosec")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.cosec());
            } else if (method.equals("sec")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.sec());
            } else if (method.equals("cot")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.cot());

            } else if (method.equals("sinh")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.sinh());
            } else if (method.equals("cosh")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.cosh());
            } else if (method.equals("tanh")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.tanh());

            } else if (method.equals("asin")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.asin());
            } else if (method.equals("acos")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.acos());
            } else if (method.equals("atan")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.atan());

            } else if (method.equals("asinh")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.asinh());
            } else if (method.equals("acosh")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.acosh());
            } else if (method.equals("atanh")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.atanh());

            } else if (method.equals("toString")) {
                System.out.println(z1 + "." + method + "()  ==  " + z1.toString());
            } else {
                System.out.println("Does the method '" + method + "' have the correct spelling?");
                inputError =  true;
            };//endif

            System.out.println();
        };//endif

        if (inputError) {
            System.out.print("usage  : ");
            System.out.println("java TestComplex method [a] [bi] [c] [di]");
            System.out.println();
        };//endif

        // debug =  false; // !!!

        // this caused more headaches than all of class Complex put together!
    };// main(String[])

}// Complex






/*  Correct my address in any reply, or it'll be treated as spam:
--                                                          
//     Alexander Anderson    <DELETE_THIS.sandy@almide.demon.co.uk>
//     Home Fone                               +44 (0) 171-794-4543
//     London, UK                    http://www.almide.demon.co.uk/ 
//     PGP print   C6 8C 55 F2 77 7B 99 9B  14 77 66 F5 B8 74 CF 12
*/
